<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <Container :max-height="1" v-if="HasFloorPlan" class="relative-position full-width">
                <div v-if="floorPlan != null" style="overflow: hidden" class="fit">
                    <FloorPlanRender ref="panzoom" v-if="floorPlan != null" :floor-plan="floorPlan" @update="UpdateSize" :workers="positions"
                                     :ratio="1" :type="$q.screen.width > $q.screen.height ? 'width' : 'height'"
                                     @select-worker="SelectWorker"
                                     :selected="selectedPosition"
                                     :compare-time="CompareTime"
                    />
                </div>
                <q-skeleton v-else height="100%" width="100%"/>
            </Container>
            <div v-else>
                <Container :max-height="1" class="row  justify-center">
                    <div class="col-lg-6 col-12">
                        <div style="height: 100%;" class="column justify-center">
                            <LottieAnimation :data="$animations.emptyBox" :loop="false" style="height: 70%;"/>
                            <q-btn :to="`/floor/${routeParams.floorId}/floorplan/create`" color="primary"> Create One
                            </q-btn>
                        </div>
                    </div>
                </Container>
            </div>
            <q-dialog position="bottom" v-model="bottomSheet" @hide="selectedPosition = null; selectedWorker = null">
                <WorkerPositionSummary :worker="selectedWorker" :position="selectedPosition"/>
            </q-dialog>
            <DateTimePicker :rules="rule" v-if="routeQueries.time !== ''" class="absolute-top-left q-ma-lg" v-model="DateTime"/>
        </DocumentWrapper>

    </q-page>
</template>

<style lang='scss' scoped>
.fp-img {
    position: absolute;
    z-index: 1;
}

.fp-text {
    position: absolute;
    top: 0;
    z-index: 3;
}

.top-canvas {
    position: absolute;
    top: 0;
    z-index: 2;
}
</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import {FloorResponse} from "src/classLibrary/APIModels/core/floorResponse";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {FloorPlanFullResponse} from "src/classLibrary/APIModels/core/floorPlanFullResponse";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import FloorPlanCanvas from "components/FloorPlan/FloorPlanCanvas.vue";
import FloorPlanTextRender from "components/FloorPlan/FloorPlanTextRender.vue";
import Container from "components/Core/Container.vue";
import LottieAnimation from "components/Core/LottieAnimation.vue";
import {None, Option, Some} from "@hqoss/monads";
import FloorPlanRender from "components/FloorPlan/FloorPlanRender.vue";
import {WorkerPositionResponse} from "src/classLibrary/APIModels/core/workerPositionResponse";
import {ApplyDiffGeneric, Orientation, WarnMessage} from "src/classLibrary/Utility";
import WorkerPositionSummary from "components/Entities/WorkerPositionSummary.vue";
import {WorkerPrincipalResponse} from "src/classLibrary/APIModels/core/workerPrincipalResponse";
import {ApiError} from "src/classLibrary/Core/Api";
import DateTimePicker from "components/Core/DateTimePicker.vue";
import {differenceInSeconds, parse} from "date-fns";
import Panzoom from "@panzoom/panzoom";

@Component({
    components: {
        DateTimePicker,
        WorkerPositionSummary,
        FloorPlanRender,
        LottieAnimation, Container, FloorPlanTextRender, FloorPlanCanvas, AnimationComponent, DocumentWrapper
    }
})
export default class FloorLiveView extends Vue {

    floor?: FloorResponse | null = null;
    floorPlan?: FloorPlanFullResponse | null = null;

    positions: { [s: string]: WorkerPositionResponse } = {};
    workers: WorkerPrincipalResponse[] = [];
    rule = [((s: string) => {
        const date = parse(s, "yyyy-MM-dd HH:mm:ss", new Date());
        const diff = differenceInSeconds(date, new Date());
        return diff < 0
    }) || 'Cannot peek into the future'];
    routeParams = {
        floorId: '',
    }
    routeQueries = {
        time: ''
    }

    get DateTime() {
        return new Date(this.routeQueries.time);
    }

    set DateTime(d) {
        this.routeQueries.time = d.toISOString();
    }


    get CompareTime() {
        return new Date(this.routeQueries.time);
    }

    rectStyle = {}

    bottomSheet = false;

    selectedPosition?: WorkerPositionResponse | null = null
    selectedWorker: WorkerPrincipalResponse | null = null;


    SelectWorker(w: WorkerPositionResponse) {
        this.selectedPosition = new Map<string, WorkerPositionResponse>(Object.entries(this.positions))
            .Find((_, v) => v.id === w.id)?.value;
        this.selectedWorker = this.workers.Find(x => x.id === w.id);
        if (this.selectedPosition != null || this.selectedWorker != null) {
            this.bottomSheet = true;
        }
    }

    UpdateSize(s: any) {
        this.rectStyle = s;
    }

    created() {
        this.Store.StoreValue.rightIcon = 'tune'
        this.Store.StoreValue.filter = 'floorplan';
        Orientation.unlock();

    }

    destroyed() {
        this.Store.StoreValue.rightIcon = ''
        this.Store.StoreValue.filter = ''
        this.Store.StoreValue.title = '';
        Orientation.lock();
    }

    panzoomStart() {
        Vue.nextTick(() => {
            const e = (this.$refs.panzoom! as any).$el as HTMLElement;
            const panzoom = Panzoom(e, {canvas: true, excludeClass: "worker-dot"})
            const parent = e.parentElement!
// No function bind needed
            parent.addEventListener('wheel', panzoom.zoomWithWheel)
        })
    }


    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    get Name() {
        const fName = this.floor?.principal.name ?? '';
        const fpName = this.floorPlan?.info.name ?? '';
        return fName + "-" + fpName;
    }

    get HasFloorPlan() {
        return this.floor?.latestFloorPlan != null;
    }

    async loadFloor(token: string): Promise<Option<FloorResponse>> {
        const r = await this.$coreApi.Get<FloorResponse>(`Floor/${this.routeParams.floorId}`, null, token)
        if (r.isErr()) {
            this.Wrap.SubmitError(r.unwrapErr())
            return None;
        }
        return Some(r.unwrap());
    }

    async loadFloorPlan(f: FloorResponse, token: string) {
        if (f.latestFloorPlan != null) {
            const fpr = await this.$coreApi.Get<FloorPlanFullResponse>(`FloorPlan/${this.routeParams.floorId}/${f.latestFloorPlan.id}`, null, token)
            if (fpr.isErr()) {
                this.Wrap.SubmitError(fpr.unwrapErr())
                return
            }
            this.floorPlan = fpr.unwrap();
        }
    }

    async loadWorkerPrincipals(token: string) {
        const p = this;
        const pid = this.PersistentStore.StoreValue.project
        const r = await this.$coreApi.Get<WorkerPrincipalResponse[]>(`Worker?projectId=${pid}`, null, token)
        if (r.isErr()) {
            this.Wrap.SubmitError(r.unwrapErr())
            return
        }
        p.workers = r.unwrap();

    }

    async init() {
        const token = await this.$auth.CoreToken;
        const f = await this.loadFloor(token);
        this.Store.StoreValue.filter = 'floorplan';
        this.Store.StoreValue.rightIcon = 'tune';
        if (f.isNone()) return;
        this.floor = f.unwrap();
        this.Store.StoreValue.title = this.floor.principal.name;
        await this.loadFloorPlan(this.floor!, token);
        await this.loadWorkerPrincipals(token);

        this.panzoomStart();
        const p = this;

        const analyticsToken = await this.$auth.AnalyticsToken;
        const r = await this.$analyticsApi.Get<{ [s: string]: WorkerPositionResponse }>(
            `History/${this.routeParams.floorId}?time=${this.routeQueries.time}`,
            null, analyticsToken);

        if (r.isErr()) {
            const e = r.unwrapErr();
            ApiError.match(e, {
                Null: (err) => {p.$q.notify(WarnMessage(err.error as string))},
                default: (e) => p.Wrap.SubmitError(e),
            })
            return;
        }
        const e = r.unwrap();
        const map = new Map<string, WorkerPositionResponse>(Object.entries(e));
        ApplyDiffGeneric(this.positions, map.AsObject(), this.$set);
    }
}
</script>
